package com.ibm.r2a.rules.rdj.examples.j2sebestpractices.synchronization;


public class ThreadYield_Example {
	
	public static void main( String[] args ){
		Data data = new Data();
		final Consumer consumer = new Consumer( data );
		final Producer producer = new Producer( data );
    
		(new Thread( new Runnable() {
			public void run() {
				consumer.consume();
			}
		})).start();
    
    
		(new Thread( new Runnable() {
			public void run() {
				producer.produce();
			}
		})).start();
	}
    
	public static final class Data {
		public Data() {
			super();
		}
		public int getValue() {
			return value;
		}
		public void setValue( int value ) {
			this.value = value;
		}
		private int value = 0;
	}

	public static final class Consumer {
		public Consumer( Data data ) {
			this.data = data;
		}
  
		public void consume() {
			System.out.println( "Consumer: consume was called" ); //$NON-NLS-1$
			System.out.println( "Consumer: yielding..." ); //$NON-NLS-1$
			Thread.yield();
			System.out.println( "Consumer: value is " + data.getValue() ); //$NON-NLS-1$
			System.out.println( "Consumer: exiting" ); //$NON-NLS-1$
		}
    
		private Data data;
	}

	public static final class Producer {
		public Producer( Data data ) {
			this.data = data;
		}
		public void produce() {
			System.out.println( "Producer: produce was called" ); //$NON-NLS-1$
			try { Thread.sleep( 3000 ); } catch (InterruptedException e) {}
			data.setValue( 1 );	System.out.println( "Producer: exiting" ); //$NON-NLS-1$
		}
		private Data data;
	}

}
